# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python or TypeScript SDK.  To install the official [Python SDK](https://pypi.org/project/humanloop/), run the following command:  ```bash pip install humanloop ```  To install the official [TypeScript SDK](https://www.npmjs.com/package/humanloop), run the following command:  ```bash npm i humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://docs.humanloop.com/).

    The version of the OpenAPI document: 4.0.1
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal, TYPE_CHECKING


class RequiredBaseMetricResponse(TypedDict):
    # A description of what the metric measures.
    description: str

    # ID of the metric. Starts with 'metric_'.
    id: str

    # The name of the metric.
    name: str

    # Python code used to calculate a metric value on each logged datapoint.
    code: str

    # Whether the metric is a global default metric. Metrics with this flag enabled cannot be deleted or modified.
    default: bool

    # If enabled, the metric is calculated for every logged datapoint.
    active: bool

    created_at: datetime

    updated_at: datetime

class OptionalBaseMetricResponse(TypedDict, total=False):
    pass

class BaseMetricResponse(RequiredBaseMetricResponse, OptionalBaseMetricResponse):
    pass
